<template>
    <div>
        <el-card class="!border-none" shadow="never">
            <el-page-header :content="$route.meta.title" @back="$router.back()" />
        </el-card>
        <el-card class="!border-none" v-loading="pager.loading" shadow="never">
            <!--            单选试题开始-->
            <div class="mt-4">
                <el-card class="!border-none mb-4" shadow="never">
                    <el-form class="mb-[-16px]" :model="queryParams" inline>
                        <el-form-item label="试卷分类" prop="category_uid">
                            <el-cascader
                                v-model="queryParams.category_uid"
                                :options="optionsData.category"
                                :props="props"
                                @change="optionHandleChange"
                            />
                        </el-form-item>
                        <el-form-item label="试题主干" prop="title">
                            <el-input
                                class="w-[280px]"
                                v-model="queryParams.title"
                                clearable
                                placeholder="请输入"
                            />
                        </el-form-item>
                        <el-form-item label="试题类型" prop="type">
                            <el-select
                                class="w-[280px]"
                                v-model="queryParams.type"
                                clearable
                                placeholder="请选择"
                            >
                                <el-option label="全部" value=""></el-option>
                                <el-option
                                    v-for="(item, index) in [
                                        { value: 1, name: '单选试题' },
                                        { value: 2, name: '多选试题' }
                                    ]"
                                    :key="index"
                                    :label="item.name"
                                    :value="item.value"
                                />
                            </el-select>
                        </el-form-item>
                        <el-form-item label="试题难度" prop="level">
                            <el-select
                                class="w-[280px]"
                                v-model="queryParams.level"
                                clearable
                                placeholder="请选择试题难度"
                            >
                                <el-option label="全部" value=""></el-option>
                                <el-option
                                    v-for="(item, index) in dictData.exam_level"
                                    :key="index"
                                    :label="item.name"
                                    :value="item.value"
                                />
                            </el-select>
                        </el-form-item>
                        <el-form-item>
                            <el-button type="primary" @click="resetPage">查询</el-button>
                            <el-button @click="resetParams">重置</el-button>
                        </el-form-item>
                    </el-form>
                </el-card>
                <el-table
                    :data="pager.lists"
                    ref="multipleTableRef"
                    style="width: 100%"
                    :cell-style="{ 'text-align': 'left' }"
                    :header-cell-style="{ 'text-align': 'left' }"
                >
                    <el-table-column label="状态" prop="type" width="100">
                        <template #default="{ row }">
                            <el-checkbox
                                size="large"
                                checked
                                v-if="row.selected"
                                @change="handleCheckedOptionChange([1, row.uid])"
                            />
                            <el-checkbox
                                size="large"
                                v-if="!row.selected"
                                @change="handleCheckedOptionChange([1, row.uid])"
                            />
                        </template>
                    </el-table-column>
                    <el-table-column label="试题分类" prop="category.title" width="150" />
                    <el-table-column label="试题主干" prop="title" />
                    <el-table-column label="试题类型" prop="type" show-overflow-tooltip>
                        <template #default="{ row }">
                            <span v-if="row.type == 1"
                                ><el-tag class="ml-2" type="success">单选</el-tag></span
                            >
                            <span v-if="row.type == 2"
                                ><el-tag class="ml-2" type="warning">多选</el-tag></span
                            >
                        </template>
                    </el-table-column>
                    <el-table-column label="试题积分" prop="score" show-overflow-tooltip />
                    <el-table-column label="显示权重" prop="sort" show-overflow-tooltip />
                    <el-table-column label="试题难度" prop="level">
                        <template #default="{ row }">
                            <dict-value :options="dictData.exam_level" :value="row.level" />
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pager" @change="getLists" />
            </div>
            <!--            单选试题结束-->
            <!--            判断试题开始-->
            <div class="mt-4">
                <el-card class="!border-none mb-4" shadow="never">
                    <el-form class="mb-[-16px]" :model="queryParams2" inline>
                        <el-form-item label="试卷分类" prop="category_uid">
                            <el-cascader
                                v-model="queryParams2.category_uid"
                                :options="optionsData.category"
                                :props="props"
                                @change="optionHandleChange2"
                            />
                        </el-form-item>
                        <el-form-item label="试题主干" prop="title">
                            <el-input
                                class="w-[280px]"
                                v-model="queryParams2.title"
                                clearable
                                placeholder="请输入"
                            />
                        </el-form-item>
                        <el-form-item label="试题难度" prop="level">
                            <el-select
                                class="w-[280px]"
                                v-model="queryParams2.level"
                                clearable
                                placeholder="请选择试题难度"
                            >
                                <el-option label="全部" value=""></el-option>
                                <el-option
                                    v-for="(item, index) in dictData.exam_level"
                                    :key="index"
                                    :label="item.name"
                                    :value="item.value"
                                />
                            </el-select>
                        </el-form-item>
                        <el-form-item>
                            <el-button type="primary" @click="resetPageJude">查询</el-button>
                            <el-button @click="resetParamsJude">重置</el-button>
                        </el-form-item>
                    </el-form>
                </el-card>
                <el-table
                    :data="pagerJude.lists"
                    style="width: 100%"
                    :cell-style="{ 'text-align': 'left' }"
                    :header-cell-style="{ 'text-align': 'left' }"
                >
                    <el-table-column label="状态" prop="type" width="100">
                        <template #default="{ row }">
                            <el-checkbox
                                size="large"
                                checked
                                v-if="row.selected"
                                @change="handleCheckedOptionChange([2, row.uid])"
                            />
                            <el-checkbox
                                size="large"
                                v-if="!row.selected"
                                @change="handleCheckedOptionChange([2, row.uid])"
                            />
                        </template>
                    </el-table-column>
                    <el-table-column label="试题分类" prop="category.title" width="150" />
                    <el-table-column label="试题主干" prop="title" min-width="200" />
                    <el-table-column label="选项一" prop="option1" show-overflow-tooltip />
                    <el-table-column label="选项二" prop="option2" show-overflow-tooltip />
                    <el-table-column label="试题答案" prop="is_correct" show-overflow-tooltip>
                        <template #default="scope">
                            <span v-if="scope.row.is_correct == 1"
                                ><el-tag class="ml-2" type="success">{{
                                    scope.row.option1
                                }}</el-tag></span
                            >
                            <span v-if="scope.row.is_correct == 2"
                                ><el-tag class="ml-2" type="danger">{{
                                    scope.row.option2
                                }}</el-tag></span
                            >
                        </template>
                    </el-table-column>
                    <el-table-column label="试题积分" prop="score" show-overflow-tooltip />
                    <el-table-column label="显示权重" prop="sort" show-overflow-tooltip />
                    <el-table-column label="试题难度" prop="level">
                        <template #default="{ row }">
                            <dict-value :options="dictData.exam_level" :value="row.level" />
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pagerJude" @change="getListsRJude" />
            </div>
            <!--            判断试题结束-->
            <!--            问答试题开始-->
            <div class="mt-4">
                <el-card class="!border-none mb-4" shadow="never">
                    <el-form class="mb-[-16px]" :model="queryParams3" inline>
                        <el-form-item label="试卷分类" prop="category_uid">
                            <el-cascader
                                v-model="queryParams3.category_uid"
                                :options="optionsData.category"
                                :props="props"
                                @change="optionHandleChange3"
                            />
                        </el-form-item>
                        <el-form-item label="试题主干" prop="title">
                            <el-input
                                class="w-[280px]"
                                v-model="queryParams3.title"
                                clearable
                                placeholder="请输入"
                            />
                        </el-form-item>
                        <el-form-item label="试题难度" prop="level">
                            <el-select
                                class="w-[280px]"
                                v-model="queryParams3.level"
                                clearable
                                placeholder="请选择试题难度"
                            >
                                <el-option label="全部" value=""></el-option>
                                <el-option
                                    v-for="(item, index) in dictData.exam_level"
                                    :key="index"
                                    :label="item.name"
                                    :value="item.value"
                                />
                            </el-select>
                        </el-form-item>
                        <el-form-item>
                            <el-button type="primary" @click="resetPageReading">查询</el-button>
                            <el-button @click="resetParamsReading">重置</el-button>
                        </el-form-item>
                    </el-form>
                </el-card>
                <el-table
                    :data="pagerReading.lists"
                    style="width: 100%"
                    :cell-style="{ 'text-align': 'left' }"
                    :header-cell-style="{ 'text-align': 'left' }"
                >
                    <el-table-column label="状态" prop="type" width="100">
                        <template #default="{ row }">
                            <el-checkbox
                                size="large"
                                checked
                                v-if="row.selected"
                                @change="handleCheckedOptionChange([3, row.uid])"
                            />
                            <el-checkbox
                                size="large"
                                v-if="!row.selected"
                                @change="handleCheckedOptionChange([3, row.uid])"
                            />
                        </template>
                    </el-table-column>
                    <el-table-column label="试题分类" prop="category.title" width="150" />
                    <el-table-column label="试题主干" prop="title" min-width="200" />
                    <el-table-column label="试题积分" prop="score" show-overflow-tooltip />
                    <el-table-column label="显示权重" prop="sort" show-overflow-tooltip />
                    <el-table-column label="试题难度" prop="level">
                        <template #default="{ row }">
                            <dict-value :options="dictData.exam_level" :value="row.level" />
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pagerReading" @change="getListsReading" />
            </div>
            <!--            问答试题结束-->
        </el-card>
    </div>
</template>

<script lang="ts" setup name="examOptionLists">
import { useJudePaging, usePaging, useReadingPaging } from '@/hooks/usePaging'
import { useDictData, useDictOptions } from '@/hooks/useDictOptions'
import { apiExamOptionLists } from '@/api/exam_option'
import { apiExamReadingLists } from '@/api/exam_reading'
import { apiExamJudeLists } from '@/api/exam_jude'
import { apiExamCollectionBindExam } from '@/api/exam_collection'
import { apiExamCategoryTree } from '@/api/exam_category'

const route = useRoute()

// 选择题筛选条件
const queryParams = reactive({
    category_uid: '',
    title: '',
    type: '',
    level: '',
    scene: 1,
    collection_id: route.query.id
})
const queryParams2 = reactive({
    category_uid: '',
    title: '',
    type: '',
    level: '',
    scene: 1,
    collection_id: route.query.id
})
const queryParams3 = reactive({
    category_uid: '',
    title: '',
    type: '',
    level: '',
    scene: 1,
    collection_id: route.query.id
})
const handleCheckedOptionChange = (value: string[]) => {
    submitCollect(parseInt(value[0]), value[1])
}

// 提交组卷
const submitCollect = (type: number, id: string) => {
    console.log(typeof type, typeof id)
    if (type === 1) {
        console.log('单选试题选中')
    } else if (type === 2) {
        console.log('判断试题选中')
    } else {
        console.log('问答试题选中')
    }
    apiExamCollectionBindExam({ type: type, option_uid: id, collection_id: route.query.id })
    console.log('提交组卷操作', type, id, route.query.id)
}

// 获取试题分类参数
const { optionsData } = useDictOptions<{
    category: any[]
}>({
    category: {
        api: apiExamCategoryTree
    }
})

// 试卷分类筛选回调
const optionHandleChange = (value) => {
    queryParams.category_uid = value[1]
}

const optionHandleChange2 = (value) => {
    queryParams2.category_uid = value[1]
}

const optionHandleChange3 = (value) => {
    queryParams3.category_uid = value[1]
}

// 获取字典数据
const { dictData } = useDictData('exam_level')

// 单选试题
const { pager, getLists, resetParams, resetPage } = usePaging({
    fetchFun: apiExamOptionLists,
    params: queryParams
})

// 阅读试题
const { pagerReading, getListsReading, resetParamsReading, resetPageReading } = useReadingPaging({
    fetchFun: apiExamReadingLists,
    params: queryParams3
})

// 判断试题
const { pagerJude, getListsRJude, resetParamsJude, resetPageJude } = useJudePaging({
    fetchFun: apiExamJudeLists,
    params: queryParams2
})

getLists()
getListsReading()
getListsRJude()
</script>
